"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var testUtils_1 = require("./testUtils");
describe('insert', function () {
    it('should insert items into the heap', function () {
        var heap = new testUtils_1.TestFibonacciHeap();
        heap.insert(1);
        heap.insert(2);
        heap.insert(3);
        heap.insert(4);
        heap.insert(5);
        chai_1.assert.deepEqual(heap.size(), 5);
    });
    it('should return the inserted node', function () {
        var heap = new testUtils_1.TestFibonacciHeap();
        var ret = heap.insert(1, { foo: 'bar' });
        chai_1.assert.equal(ret.key, 1);
        chai_1.assert.deepEqual(ret.value, { foo: 'bar' });
    });
    it('should insert multiple items with the same key', function () {
        var heap = new testUtils_1.TestFibonacciHeap();
        heap.insert(1);
        heap.insert(1);
        chai_1.assert.equal(1, heap.extractMinimumUnsafe().key);
        chai_1.assert.equal(1, heap.extractMinimumUnsafe().key);
    });
});
//# sourceMappingURL=insert.test.js.map